macro(setup_compiler_specifics)
  if(MSVC)
    string(REGEX REPLACE "/W[0-4]" "/W0" flags "${CMAKE_CXX_FLAGS}")
    set(CMAKE_CXX_FLAGS "${flags} /bigobj /MP" CACHE STRING "" FORCE)
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_UNICODE -DUNICODE)
  elseif(CMAKE_COMPILER_IS_GNUCXX)
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCXX_VERSION)
    if(GCXX_VERSION VERSION_EQUAL 4.6)
      set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-partial-inlining")
    endif()
  endif()
endmacro()